<?php

namespace Teknisa\EST\Modules\Ajuste\Factories;

use Doctrine\ORM\EntityManager;
    
class LanctoestoqAjusteFactory {
    
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function getProdutoTabela($parameters){
        $sql = "";
        if(isset($parameters["P_CDARVPROD"])){
           $sql = "SELECT DISTINCT PF.CDFILIAL,
                        P.CDPRODUTO,
                        P.CDARVPROD,
                        P.NMPRODUTO,
                        P.SGUNIDADE,
                        P.VRFATOCONV,
                        P.CDPRODESTO AS CDPRODMOVI,
                        P.NRORG,
                        ' ' AS CDALMOXARIFE,
                        ' ' AS CDLOCALESTOQ,
                        ' ' AS NRLOTEESTQ,
                        ' ' AS NRSUBLOTE,
                        0 AS VRUNILANCTO,
                        0 AS VRTOTLANCTO,
                        0 AS VRLANCTOEST,
                        0 AS VRUNITBRUT,
                        0 AS QTTOTLANCTO
                    FROM
                        PRODUTO P JOIN
                        PRODFILI PF ON P.CDPRODUTO = PF.CDPRODUTO
                    WHERE
                        P.IDATIVO = 'S' AND
                        PF.IDATIVO = 'S' AND
                        P.CDARVPROD = :P_CDARVPROD AND
                        PF.CDFILIAL = :P_CDFILIAL"; 
        }else if(isset($parameters["P_CDBARPRODUTO"])){
            $sql = "SELECT DISTINCT PF.CDFILIAL,
                            P.CDPRODUTO,
                            P.CDARVPROD,
                            P.NMPRODUTO,
                            P.SGUNIDADE,
                            P.VRFATOCONV,
                            P.CDPRODESTO AS CDPRODMOVI,
                            P.NRORG,
                            ' ' AS CDALMOXARIFE,
                            ' ' AS CDLOCALESTOQ,
                            ' ' AS NRLOTEESTQ,
                            ' ' AS NRSUBLOTE,
                            0 AS VRUNILANCTO,
                            0 AS VRTOTLANCTO,
                            0 AS VRLANCTOEST,
                            0 AS VRUNITBRUT,
                            0 AS QTTOTLANCTO
                      FROM PRODUTO P
                      JOIN PRODFILI PF 
                        ON P.CDPRODUTO = PF.CDPRODUTO
                     WHERE P.CDBARPRODUTO = :P_CDBARPRODUTO
                       AND PF.CDFILIAL = :P_CDFILIAL
                     UNION
                    SELECT  PF.CDFILIAL,
                            P.CDPRODUTO,
                            P.CDARVPROD,
                            P.NMPRODUTO,
                            P.SGUNIDADE,
                            P.VRFATOCONV,
                            P.CDPRODESTO AS CDPRODMOVI,
                            P.NRORG,
                            ' ' AS CDALMOXARIFE,
                            ' ' AS CDLOCALESTOQ,
                            ' ' AS NRLOTEESTQ,
                            ' ' AS NRSUBLOTE,
                            0 AS VRUNILANCTO,
                            0 AS VRTOTLANCTO,
                            0 AS VRLANCTOEST,
                            0 AS VRUNITBRUT,
                            0 AS QTTOTLANCTO
                      FROM PRODUTO P
                      LEFT JOIN CDBARRAPROD CDBP
                        ON P.CDPRODUTO = CDBP.CDPRODUTO
                      LEFT JOIN PRODFILI PF 
                        ON P.CDPRODUTO = PF.CDPRODUTO
                     WHERE
                        P.IDATIVO = 'S' AND
                        PF.IDATIVO = 'S' AND
                        CDBP.CDBARRAPROD = :P_CDBARPRODUTO
                        AND PF.CDFILIAL = :P_CDFILIAL"; 
            
        } else{
            $sql = "SELECT DISTINCT PF.CDFILIAL,
                        P.CDPRODUTO,
                        P.CDARVPROD,
                        P.NMPRODUTO,
                        P.SGUNIDADE,
                        P.VRFATOCONV,
                        P.CDPRODESTO AS CDPRODMOVI,
                        P.NRORG,
                        ' ' AS CDALMOXARIFE,
                        ' ' AS CDLOCALESTOQ,
                        ' ' AS NRLOTEESTQ,
                        ' ' AS NRSUBLOTE,
                        0 AS VRUNILANCTO,
                        0 AS VRTOTLANCTO,
                        0 AS VRLANCTOEST,
                        0 AS VRUNITBRUT,
                        0 AS QTTOTLANCTO
                    FROM
                        PRODUTO P JOIN
                        PRODFILI PF ON P.CDPRODUTO = PF.CDPRODUTO
                    WHERE
                        P.IDATIVO = 'S' AND
                        PF.IDATIVO = 'S' AND
                        P.CDPRODUTO = :P_CDPRODUTO AND
                        PF.CDFILIAL = :P_CDFILIAL"; 
        }
        
        
        $std = $this->connection->prepare($sql);
        $std->execute($parameters);
        $result = $std->fetchAll();
        if(isset($result[0])){
            return $result[0];
        } else{
            return null;
        }
    }
    
    public function insertLoteProduto($cdfilial, $cdproduto, $nrloteestq, $nrsublote, $dtlancamento, $dtvalilote, $dtfrabric){
        try{
            $params = array(
                'P_CDFILIAL'   => $cdfilial,
                'P_CDPRODUTO'  => $cdproduto,
                'P_NRLOTEESTQ' => $nrloteestq,
                'P_NRSUBLOTE'  => $nrsublote,
                'P_DTLANCAMENTO' => $dtlancamento,
                'P_DTVALILOTE' => $dtvalilote,
                'P_DTFABRPROD' => $dtfrabric
            );
            $query = "INSERT INTO LOTE
                    (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE, DTVALILOTE, DTFABRPROD)
                    (SELECT :P_CDFILIAL CDFILIAL, :P_NRLOTEESTQ NRLOTEESTQ, :P_NRSUBLOTE NRSUBLOTE, :P_CDPRODUTO CDPRODUTO,
                    'L' IDSTATLOTE, :P_DTLANCAMENTO DTENTRLOTE, :P_DTVALILOTE DTVALILOTE, :P_DTFABRPROD DTFABRPROD
                     FROM DUAL
                     MINUS
                     SELECT CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, 'L', :P_DTLANCAMENTO DTENTRLOTE, :P_DTVALILOTE DTVALILOTE, :P_DTFABRPROD DTFABRPROD
                     FROM LOTE
                     WHERE  :P_CDFILIAL   =  CDFILIAL     AND
                            :P_NRLOTEESTQ =  NRLOTEESTQ   AND
                            :P_NRSUBLOTE  =  NRSUBLOTE    AND
                            :P_CDPRODUTO  =  CDPRODUTO)";

            $this->entityManager->getConnection()->executeQuery($query, $params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function insertAlmoxarife($cdfilial, $cdalmoxarife, $dsalmoxarife, $nrorg){
        try{
            $params = array(
                'P_CDFILIAL'   => $cdfilial,
                'P_CDALMOXARIFE'  => $cdalmoxarife,
                'P_DSALMOXARIFE' => $dsalmoxarife,
                'P_NRORG'  => $nrorg
            );
            $query = "INSERT INTO ALMOXARIFADO
                    (CDFILIAL, CDALMOXARIFE, DSALMOXARIFE, NRORG)
                    (SELECT :P_CDFILIAL CDFILIAL, :P_CDALMOXARIFE CDALMOXARIFE, :P_DSALMOXARIFE DSALMOXARIFE, NRORG
                     FROM ALMOXARIFADO
                     MINUS
                     SELECT CDFILIAL, CDALMOXARIFE, DSALMOXARIFE, NRORG
                     FROM ALMOXARIFADO
                     WHERE  :P_CDFILIAL     =  CDFILIAL     AND
                            :P_CDALMOXARIFE  =  CDALMOXARIFE  AND
                            :P_NRORG        =  NRORG)";
                            
            $this->entityManager->getConnection()->executeQuery($query, $params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function insertLocalEstoque($cdfilial, $cdalmoxarife, $cdlocalestoq, $dslocalestoq, $estdesmemb, $nrorg){
        try{
            $params = array(
                'P_CDFILIAL'     => $cdfilial,
                'P_CDALMOXARIFE' => $cdalmoxarife,
                'P_CDLOCALESTOQ' => $cdlocalestoq,
                'P_DSLOCALESTOQ' => $dslocalestoq,
                'P_IDESTDESMEMB' => $estdesmemb,
                'P_NRORG'        => $nrorg
            );
            $query = "INSERT INTO LOCALESTOQUE
                    (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DSLOCALESTOQ, IDESTDESMEMB, NRORG)
                    (SELECT :P_CDFILIAL CDFILIAL, :P_CDALMOXARIFE CDALMOXARIFE, :P_CDLOCALESTOQ CDLOCALESTOQ,
                    :P_DSLOCALESTOQ DSLOCALESTOQ, :P_IDESTDESMEMB IDESTDESMEMB, NRORG
                     FROM LOCALESTOQUE
                     MINUS
                     SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DSLOCALESTOQ, IDESTDESMEMB, NRORG
                     FROM LOCALESTOQUE
                     WHERE  :P_CDFILIAL     =  CDFILIAL     AND
                            :P_CDALMOXARIFE =  CDALMOXARIFE AND
                            :P_CDLOCALESTOQ =  CDLOCALESTOQ AND
                            :P_NRORG        =  NRORG)";
                            
            $this->entityManager->getConnection()->executeQuery($query, $params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getSegMercFilial($cdFilial) {
        $sql = "SELECT
                   F.CDFILIAL, F.CDSEGMER
                FROM
                   FILIAL F
                WHERE
                   F.CDFILIAL = :P_CDFILIAL";
                   
        $params = array("P_CDFILIAL" => $cdFilial);           
                   
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();           
    } 
    
    public function checkAlmoxExists($cdfilial, $cdalmoxarife, $nrorg){
        $params = array(
            'P_CDFILIAL'   => $cdfilial,
            'P_CDALMOXARIFE'  => $cdalmoxarife,
            'P_NRORG'  => $nrorg
        );
        $query = 'SELECT CDFILIAL, CDALMOXARIFE, DSALMOXARIFE, NRORG
             FROM ALMOXARIFADO
             WHERE  :P_CDFILIAL     =  CDFILIAL     AND
                    :P_CDALMOXARIFE  =  CDALMOXARIFE  AND
                    :P_NRORG        =  NRORG';
        $std = $this->connection->prepare($query);
        $std->execute($params);
        $result = $std->fetchAll();
        return count($result) > 0 ? true :false;
    }
    public function checkLocalExists($cdfilial, $cdalmoxarife, $cdlocalestoq, $nrorg){
        $params = array(
            'P_CDFILIAL'     => $cdfilial,
            'P_CDALMOXARIFE' => $cdalmoxarife,
            'P_CDLOCALESTOQ' => $cdlocalestoq,
            'P_NRORG'        => $nrorg
        );
        $query = "SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DSLOCALESTOQ, IDESTDESMEMB, NRORG
             FROM LOCALESTOQUE
             WHERE  :P_CDFILIAL     =  CDFILIAL     AND
                    :P_CDALMOXARIFE =  CDALMOXARIFE AND
                    :P_CDLOCALESTOQ =  CDLOCALESTOQ AND
                    :P_NRORG        =  NRORG";
                            
        $std = $this->connection->prepare($query);
        $std->execute($params);
        $result = $std->fetchAll();
        return count($result) > 0 ? true :false;
    }
    
    public function getRetiradaSetor($cdfilial, $nrlancestq){
        $params = array(
            'P_CDFILIAL'   => $cdfilial,
            'P_NRLANCESTQ'  => $nrlancestq
        );
        $query = 'SELECT
                   AR.CDFILIAL, AR.NRLANCESTQ, AR.CDFILIALRET,
                   AR.NRLANCESTRET,  RE.NRRETEST, RE.DTRETEST
                FROM
                   RETIRADAESTO RE, AJURELACRET AR
                WHERE
                   (AR.CDFILIAL = :P_CDFILIAL  ) AND
                 (AR.NRLANCESTQ      = :P_NRLANCESTQ) AND
                   (AR.NRLANCESTRET = RE.NRLANCESTQ) AND
                   (RE.CDFILIALLAN  = :P_CDFILIAL  )';
        $std = $this->connection->prepare($query);
        $std->execute($params);
        $result = $std->fetchAll();
        return $result;
    }
    
    public function getRetiradaServico($cdfilial, $nrlancestq){
        $params = array(
            'P_CDFILIAL'   => $cdfilial,
            'P_NRLANCESTQ'  => $nrlancestq
        );
        $query = 'SELECT
                   AR.CDFILIAL, AR.NRLANCESTQ, AR.CDFILIALRET, AR.NRLANCESTRET,
                   RE.NRRETIRADA, CD.NRCARDAPIO, CD.CDSERVFILI, DTRETIRADA
                FROM
                   CARDADIA CD, RETIRADA RE, AJURELACRET AR
                WHERE
                   (CD.NRCARDAPIO   = RE.NRCARDAPIO)    AND
                   (CD.CDFILIAL     = RE.CDFILIAL)      AND
                   (RE.NRLANCESTQ   = AR.NRLANCESTRET)  AND
                   (RE.CDFILANCESTQ = AR.CDFILIAL)      AND
                   (AR.CDFILIAL = :P_CDFILIAL)      AND
                   (AR.NRLANCESTQ   = :P_NRLANCESTQ)    AND
                   (AR.CDFILIAL     = :P_CDFILIAL)';
        $std = $this->connection->prepare($query);
        $std->execute($params);
        $result = $std->fetchAll();
        return $result;
    }
    
    public function deleteRetiradaEsto($cdfilial, $nrlancestq){
        try{
            $params = array(
                'P_CDFILIAL'   => $cdfilial,
                'P_NRLANCESTQ'  => $nrlancestq
            );
            $query   = "DELETE RETIRADAESTO
                        WHERE NRLANCESTQ = :P_NRLANCESTQ
                        AND CDFILIALLAN     = :P_CDFILIAL";
            
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function deleteAjuRelaRet($cdfilial, $nrlancestq){
        try{
            $params = array(
                'P_CDFILIAL'   => $cdfilial,
                'P_NRLANCESTQ'  => $nrlancestq
            );
            $query   = "DELETE AJURELACRET
                        WHERE CDFILIAL = :P_CDFILIAL
                        AND NRLANCESTQ = :P_NRLANCESTQ";
                            
            $std = $this->connection->prepare($query);
            $std->execute($params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function deleteCardadia($cdservfili, $nrcardapio, $dtcardapio){
        try{
            $params = array(
                'P_CDSERVFILI'   => $cdservfili,
                'P_NRCARDAPIO'  => $nrcardapio,
                'P_DTCARDAPIO'  => $dtcardapio
            );
            
            $query   = "DELETE CARDADIA
                        WHERE CDSERVFILI = :P_CDSERVFILI 
                        AND NRCARDAPIO = :P_NRCARDAPIO
                        AND DTCARDAPIO = :P_DTCARDAPIO";
                            
            $std = $this->connection->prepare($query);
            $std->execute($params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function deleteRetirada($cdfilimovi, $nrcardapio, $dtretirada, $cdfilial, $nrlacestq, $nrlanctoAjuste, $nrretirada){
        try{
            $params = array(
                'P_CDFILIMOVI'    => $cdfilial,
                'P_NRRETIRADA'    => $nrretirada,
                'P_NRCARDAPIO'    => $nrcardapio,
                'P_DTRETIRADA'    => $dtretirada,
                'P_CDFILANCESTQ'  => $cdfilial,
                'P_NRLANCESTQ'    => $nrlacestq
            );

            $query   = "DELETE RETIRADA
                        WHERE CDFILIAL     = :P_CDFILIMOVI
                        AND   NRRETIRADA   = :P_NRRETIRADA
                        AND   NRCARDAPIO   = :P_NRCARDAPIO
                        AND   DTRETIRADA   = :P_DTRETIRADA 
                        AND   CDFILANCESTQ = :P_CDFILANCESTQ 
                        AND   NRLANCESTQ   = :P_NRLANCESTQ";
                            
            $std = $this->connection->prepare($query);
            $std->execute($params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function deleteItemReti($cdfilial, $nrretirada, $nrcardapio, $nrsequitreti, $cdproduto){
        $sql = "DELETE FROM ITEMRETI
                WHERE CDFILIAL = :P_CDFILIAL AND
                NRRETIRADA = :P_NRRETIRADA AND
                NRCARDAPIO = :P_NRCARDAPIO AND
                NRSEQUITRETI = :P_NRSEQUITRETI AND
                CDPRODUTO = :P_CDPRODUTO";
               
        $params = array("P_CDFILIAL" => $cdfilial,
                        "P_NRRETIRADA" => $nrretirada,
                        "P_NRCARDAPIO" => $nrcardapio,
                        "P_NRSEQUITRETI" => $nrsequitreti,
                        "P_CDPRODUTO" => $cdproduto);
               
        $std = $this->connection->prepare($sql);
        return $std->execute($params);     
    }
    
}