package com.javaseleniumtemplate.tests;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.MovimentacaoDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.MovimentacaoDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

import java.io.File;

public class MovimentacaoDeEstoqueTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    MovimentacaoDeEstoqueFlows movimentacaoDeEstoqueFlows;
    MovimentacaoDeEstoquePage movimentacaoDeEstoquePage;


    @Test(priority = 1, description = "Est-12")
    public void GerarMovimentacaoDeEstoquePDF(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        movimentacaoDeEstoqueFlows = new MovimentacaoDeEstoqueFlows();
        movimentacaoDeEstoquePage = new MovimentacaoDeEstoquePage();


        //Parameteres_Lançamento:

        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descTipoDeCusto = "Custo Médio Líquido Atual";
        String downloadPath = "/Users/Teknisa Software/Downloads";
        String nomeArquivo = "Est31300MovEstoquÇe.pdf";

        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoMovimentacaoDeEstoque();
        movimentacaoDeEstoqueFlows.GerarMovimentacaoDeEstoque(descUnidade,descAlmoxarifado,descLote,descProduto);


       //validacao
        File arquivo = new File(downloadPath + File.separator + nomeArquivo);
        if(arquivo.exists()){
            System.out.println("Download Realizado com Sucesso");
        }else{
            System.out.println("Ocorreu alguma falha no download, verifique se o arquivo esta correto na pasta");
        }
    }

    @Test(priority = 2,description = "Est-XX")

    public void GerarMovimentacaoDeEstoqueXLSX(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        movimentacaoDeEstoqueFlows = new MovimentacaoDeEstoqueFlows();
        movimentacaoDeEstoquePage = new MovimentacaoDeEstoquePage();


        //Parameteres_Lançamento:

        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descTipoDeCusto = "Custo Médio Líquido Atual";
        String downloadPath = "/Users/Teknisa Software/Downloads";
        String nomeArquivo = "Est31300MovEstoquIe.xlsx";


        //validacao
        File arquivo = new File(downloadPath + File.separator + nomeArquivo);
        if(arquivo.exists()){
            System.out.println("Download Realizado com sucesso");

        }else{
            System.out.println("ocorreu aguma falha no download, verifique se o arquivo esta correto");
        }
        //Rotinas:
        loginFlows.efetuarLogin();

        mainFlows.AcessandoMovimentacaoDeEstoque();
        movimentacaoDeEstoqueFlows.GerarMovimentacaoDeEstoqueXLSX(descUnidade,descAlmoxarifado,descLote,descProduto, descTipoDeCusto);

    }

}
